%define major 1
%define libnameold %mklibname selinux 1
%define libname    %mklibname selinux %{major}
%define libnamedevel %mklibname selinux -d
%define libnamestaticdevel %mklibname selinux -d -s
%define libsepolver 2.5

Name:           libselinux
Version:        2.5
Release:        %mkrel 6
Summary:        SELinux library and simple utilities
License:        Public Domain
Group:          System/Libraries
URL:            http://oss.tresys.com/git/selinux.git
Source0:        http://oss.tresys.com/git/selinux.git/%{name}-%{version}.tar.gz
Source1:        selinuxconlist.8
Source2:        selinuxdefcon.8
BuildRequires:  sepol-static-devel >= %{libsepolver}
BuildRequires:  pkgconfig(python2)
BuildRequires:  python
BuildRequires:  pkgconfig(python3)
BuildRequires:  python3
BuildRequires:  pcre-devel
BuildRequires:  swig
BuildRequires:  ruby-devel 
BuildRequires:	lzma-devel
BuildRequires:  ruby

%description
Security-enhanced Linux is a patch of the Linux® kernel and a
number of utilities with enhanced security functionality designed
to add mandatory access controls to Linux. The Security-enhanced
Linux kernel contains new architectural components originally
developed to improve the security of the Flask operating system.
These architectural components provide general support for the
enforcement of many kinds of mandatory access control policies,
including those based on the concepts of Type Enforcement®,
Role-based Access Control, and Multi-level Security.

libselinux provides an API for SELinux applications to get and set
process and file security contexts and to obtain security policy
decisions. Required for any applications that use the SELinux API.

%package -n %{libname}
Summary:        SELinux library and simple utilities
Group:          System/Libraries
Requires(pre):  filesystem >= 2.1.9
Provides:       libselinux = %{version}-%{release}
Provides:       selinux = %{version}-%{release}

%description -n %{libname}
libselinux provides an API for SELinux applications to get and set
process and file security contexts and to obtain security policy
decisions. Required for any applications that use the SELinux API.

%package -n %{libnamedevel}
Summary:        Development libraries and header files for %{name}
Group:          Development/C
Requires(pre):  filesystem >= 2.1.9
Requires:       %{libname} = %{version}-%{release}
Provides:       libselinux-devel = %{version}-%{release}
Provides:       selinux-devel = %{version}-%{release}
Obsoletes:      %{libnameold}-devel < %{version}-%{release}

%description -n %{libnamedevel}
The selinux-devel package contains the libraries and header
files needed for developing SELinux applications.

%package -n %{libnamestaticdevel}
Summary:        Static development libraries for %{name}
Group:          Development/C
Provides:       selinux-static-devel = %{version}-%{release}
Requires:       %{libnamedevel} = %{version}-%{release}

%description -n %{libnamestaticdevel}
The selinux-static-devel package contains the static libraries
needed for developing SELinux applications.

%package utils
Summary:        Utilities for %{name}
Group:          System/Kernel and hardware
Requires(pre):  filesystem >= 2.1.9

%description utils
This package contains numerous applications utilizing %{name}.

%package    python
Summary:        Python bindings for %{name}
Group:          Development/Python
Provides:       python-selinux = %{name}-%{version}
Obsoletes:      python-selinux < %{version}-%{release}
BuildRequires:  python

%description python
This package contains python bindings for %{name}.

%package    python3
Summary:        Python 3 bindings for %{name}
Group:          Development/Python
Provides:       python3-selinux = %{name}-%{version}
Obsoletes:      python3-selinux < %{version}-%{release}
BuildRequires:  python3

%description  python3
This package contains python 3 bindings for %{name}.

%prep
%setup -q

%build
# Taken from Fedora
# To support building the Python wrapper against multiple Python runtimes
# Define a function, for how to perform a "build" of the python wrapper against
# a specific runtime:
BuildPythonWrapper() {
  BinaryName=$1

  # Perform the build from the upstream Makefile:
  %make \
    PYTHON=$BinaryName \
    LIBDIR="%{_libdir}" CFLAGS="-g %{optflags}" \
    pywrap
}

make clean
%make LIBDIR="%{_libdir}" CFLAGS="-g %{optflags}"  swigify
%make LIBDIR="%{_libdir}" CFLAGS="-g %{optflags}"  all

BuildPythonWrapper %{__python2}

BuildPythonWrapper %{__python3}

%install
install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_includedir}
install -d %{buildroot}%{_libdir}
install -d %{buildroot}%{_mandir}/man3
install -m 644 %{SOURCE1} %{buildroot}%{_mandir}/man3/
install -m 644 %{SOURCE2} %{buildroot}%{_mandir}/man3/

# (cg) needed to link during make install :s
cp %{_libdir}/libsepol.a %{buildroot}%{_libdir}

InstallPythonWrapper() {
  BinaryName=$1

%make \
    PYTHON=$BinaryName \
    DESTDIR=%{buildroot} \
    LIBDIR="%{buildroot}%{_libdir}" \
    SHLIBDIR="%{buildroot}%{_libdir}" \
    install pywrap install-pywrap
}

InstallPythonWrapper %{__python2}

InstallPythonWrapper %{__python3}

pushd %{buildroot}%{_libdir}
ln -sf libselinux.so.%{major} libselinux.so
popd

# (cg) No longer needed now
rm -f %{buildroot}%{_libdir}/libsepol.a

%files -n %{libname}
%{_libdir}/libselinux.so.%{major}

%files utils
%doc ChangeLog LICENSE
%{_sbindir}/*
%{_mandir}/man?/*

%files -n %{libnamedevel}
%{_includedir}/selinux/*.h
%{_libdir}/*.so
%{_libdir}/pkgconfig/libselinux.pc

%files -n %{libnamestaticdevel}
%{_libdir}/*.a

%files  python
%{python2_sitearch}/selinux/

%files  python3
%{python3_sitearch}/selinux/


%changelog
* Tue Jul 05 2016 spuhler <spuhler> 2.5-6.mga6
+ Revision: 1039048
- added Obsoletes: python-selinux < %%{version}-%%{release} to make it upgrade from mga5

* Sat Apr 23 2016 tv <tv> 2.5-5.mga6
+ Revision: 1005572
- provides libselinux-devel

* Thu Mar 31 2016 luigiwalser <luigiwalser> 2.5-4.mga6
+ Revision: 997252
- provide python-selinux

* Wed Mar 02 2016 spuhler <spuhler> 2.5-3.mga6
+ Revision: 983681
- changed names of python packages

* Thu Feb 25 2016 spuhler <spuhler> 2.5-1.mga6
+ Revision: 979145
- we still call python2 python
- upgrade to vers. 2.5
- upgrade to vers. 2.5

* Tue Jan 19 2016 daviddavid <daviddavid> 2.4-2.mga6
+ Revision: 925765
- add python3 package (python3-selinux)
- use new python macros

* Sun Nov 15 2015 spuhler <spuhler> 2.4-1.mga6
+ Revision: 903136
- ugrade to vers. 2.4
  * removed already incorporated patch

* Fri Aug 21 2015 tmb <tmb> 2.3-5.mga6
+ Revision: 867721
- rebuild for new gcc

* Wed Oct 15 2014 umeabot <umeabot> 2.3-4.mga5
+ Revision: 745403
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 2.3-3.mga5
+ Revision: 726862
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 2.3-2.mga5
+ Revision: 681773
- Mageia 5 Mass Rebuild

* Sun Jun 15 2014 spuhler <spuhler> 2.3-1.mga5
+ Revision: 636656
- upgrade to ver 2.3

* Sat May 31 2014 pterjan <pterjan> 2.2.2-2.mga5
+ Revision: 628308
- Rebuild for new Python

* Thu Feb 06 2014 spuhler <spuhler> 2.2.2-1.mga5
+ Revision: 584805
- added BuildRequires: lzma-devel
- upgrade to ver. 2.2.2
- rediffed patch

* Sat Oct 19 2013 umeabot <umeabot> 2.1.13-2.mga4
+ Revision: 535968
- Mageia 4 Mass Rebuild

* Tue Feb 26 2013 spuhler <spuhler> 2.1.13-1.mga4
+ Revision: 400401
- upgrade to 2.1.13
 * audit2why: make sure path is nul terminated
 *utils: new file context regex compiler
 *label_file: use precompiled filecontext when possible
 *do not leak mmapfd
 *sefcontontext_compile: Add error handling to help debug problems in libsemanage.
 *man: make selinux.8 mention service man pages
 *audit2why: Fix segfault if finish() called twice
 *audit2why: do not leak on multiple init() calls
 *mode_to_security_class: interface to translate a mode_t in to a security class
 *audit2why: Cleanup audit2why analysys function
 *man: Fix program synopsis and function prototypes in man pages
 *man: Fix man pages formatting
 *man: Fix typo in man page
 *man: Add references and man page links to _raw function variants
 *Use ENOTSUP instead of EOPNOTSUPP for getfilecon functions
 *man: context_new(3): fix the return value description
 *selinux_status_open: handle error from sysconf
 *selinux_status_open: do not leak statusfd on exec
 *Fix errors found by coverity
 *Change boooleans.subs to booleans.subs_dist.
 *optimize set*con functions
 *pkg-config do not specifc ruby version
 *unmap file contexts on selabel_close()
 *do not leak file contexts with mmap'd backend
 *sefcontext_compile: do not leak fd on error
 *matchmediacon: do not leak fd
 *src/label_android_property: do not leak fd on error
- updated patch from rhat for 2.1.13

* Sat Jan 12 2013 umeabot <umeabot> 2.1.12-3.mga3
+ Revision: 358137
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Dec 02 2012 spuhler <spuhler> 2.1.12-2.mga3
+ Revision: 324836
- reversed to filesystem >=2.1.9 for the time being

* Sun Dec 02 2012 spuhler <spuhler> 2.1.12-1.mga3
+ Revision: 324734
- added BuilRequires: pcre-devel
- upgrade to 2.1.12
  arranged spec file to make it build
- added selinixdefcon file
- added selinuxconlist file

* Mon Sep 17 2012 fwang <fwang> 2.1.11-2.mga3
+ Revision: 294805
- update file list
- force regenerate symlink

* Sat Jul 21 2012 colin <colin> 2.1.11-1.mga3
+ Revision: 273164
- Add BuildRequire for swig
- New version: 2.1.11
- Update for usrmove

  + tv <tv>
    - new release
    - new release

* Fri Feb 11 2011 dmorgan <dmorgan> 2.0.78-3.mga1
+ Revision: 50036
- Remove mdv macros
- imported package libselinux

